
/*
	JINROH-BBS Simulation Framework
	2004 mitusru nishibe
*/

// Augur Phycic Hunter Sharer Madman Villager Wolf

#include <stdio.h>
#include <stdlib.h>

#include "jinroh.h"

const char rolesname[][3] = {"","","","","","T",""};
const char rolename[][16] = {"肢t","\","l","L","l","lT","l"};
const char playername[][16] = {"@^[","[bc","W]","g[}X","jRX","fB[^[","y[^[","[U","Ar","J^i","Ibg[","Aq","p","Ru","W[i"};
const char playersname[][4] = {"","","W","g","j","f","y","","A","J","I","","p","",""};
const char playernamelist[] = {"WgjfyAJIp"};


void Word::sets( TYPE t,int d,int d2 ) {
	player = System;
	type = t;
	data = d;
	data2 = d2;
}
void Word::set( TYPE t,int d,int d2 ) {
	type = t;
	data = d;
	data2 = d2;
}


void Word::print()
{
	printf( "%s:",playername[player]);
	switch( type ) {
		case CO:printf( "%sCO܂",rolename[data] );break;
		case AUGUR_RESULT:printf( "%s%sł",playername[data],data2==White?"":"" );break;
	}
	printf( "\n" );
}


WolfBBS::WolfBBS() {
	for( int i=0;i<LimitNum;i++ ) {
		people[i].person = 0;
	}
	bprint = false;
}

void WolfBBS::init()
{
	destroy();
	state.init();
	maxp = 0;
}

void WolfBBS::enableprint()
{
	bprint = true;
}

void WolfBBS::destroy()
{
	for( int i=0;i<LimitNum;i++ ) {
		delete people[i].person;
		people[i].person = 0;
	}
}


void WolfBBS::shuffle()
{
	for( int i=maxp*4;i>0;i-- ) {
		int n=rand()%maxp,m=rand()%maxp;
		People t;
		t = people[n];
		people[n] = people[m];
		people[m] = t;
	}
	for( int i=0;i<LimitNum;i++ ) {
		people[i].person->myplayerno = i;
	}
}

void WolfBBS::add( int type,Person *person )
{
	people[maxp].type   = type;
	people[maxp].person = person;
	state.live[maxp] = true;
	maxp++;
}

void WolfBBS::talk()
{
	bool bTalk;
	do {
		bTalk = false;
		for( int i=0;i<maxp;i++ ) {
			if( !state.getlive(i) ) continue;
			Word w;
			w.player = i;
			w.data = w.data2 = 0;
			if( !people[i].person->Talk( state,w ) ) continue;
			if( w.type>=Word::WOLF && people[i].type!=Wolf ) continue;
			bTalk = true;

			for( int j=0;j<maxp;j++ ) {
				if( i!=j && (w.type<Word::WOLF || people[j].type==Wolf) ) people[j].person->Listen( state,w );
			}

			if( bprint && w.type<Word::WOLF ) {
				w.print();
			}
		}
	} while( bTalk );
}

void WolfBBS::augury()
{
	for( int i=0;i<maxp;i++ ) {
		if( !state.getlive(i) ) continue;
		if( people[i].type != Augur ) continue;
		int n = people[i].person->Augury( state );
		Word w;
		w.sets( Word::AUGUR_RESULT,n,people[n].type==Wolf ? Black : White );
		people[i].person->Listen( state,w );
	}
}

void WolfBBS::hang()
{
	int vote[LimitNum];
	for( int i=0;i<maxp;i++ ) vote[i] = 0;
	int m = 0;
	for( int i=0;i<maxp;i++ ) {
		if( !state.getlive(i) ) continue;
		int n = people[i].person->Hang(state);
		if( n<0 || n>=maxp ) n = rand()%maxp;
		while( n==i || !state.getlive(n) ) n = rand()%maxp;
		vote[n] ++;
		if( vote[n]>m ) m = vote[n];
		state.hang[i] = n;
		if( bprint ) printf( playersname[n] );
	}
	if( bprint ) printf("\n");
	int n = rand()%maxp;
	while( vote[n]!=m ) { n = rand()%maxp; }
	state.live[n] = false;

	Word w;
	w.sets( Word::HANGED,n ); 
	for( int i=0;i<maxp;i++ ) {
		if( state.getlive(i) ) people[i].person->Listen( state,w );
	}
	if( bprint ) {
		printf( "%sYꂽ\n",playername[n] );
	}
}

void WolfBBS::wolf()
{
	int vote[LimitNum];
	for( int i=0;i<maxp;i++ ) vote[i] = 0;
	int m = 0;
	for( int i=0;i<maxp;i++ ) {
		if( !state.getlive(i) ) continue;
		if( people[i].type!=Wolf ) continue;

		int n = people[i].person->Eat(state);
		if( n<0 || n>=maxp ) {
			n = rand()%maxp;
			while( people[n].type==Wolf || !state.getlive(n) ) n = rand()%maxp;
		}
		vote[n] ++;
		if( vote[n]>m ) m = vote[n];
	}
	int n = rand()%maxp;
	while( vote[n]!=m ) { n = rand()%maxp; }
	bool success = state.getlive(n);

	// hunter
	for( int i=0;i<maxp;i++ ) {
		if( !state.getlive(i) || people[i].type!=Hunter ) continue;
		int j = people[i].person->Hunt( state );
		if( j<0 || j>=maxp ) {
			do { j = rand()%maxp; } while( i==j || !state.getlive(j) );
		}
		if( j==n ) {
			success = false;
		}
	}

	if( success ) {
		state.live[n] = false;
		Word w;
		w.sets( Word::WOLFED,n ); 
		for( int i=0;i<maxp;i++ ) {
			if( state.getlive(i) ) people[i].person->Listen( state,w );
		}
		if( bprint ) {
			printf( "%scȎpŔꂽ\n",playername[n] );
		}
	} else {
		if( bprint ) {
			printf( "͏P͂Ȃ悤\n" );
		}
	}
}

void WolfBBS::tomorror()
{
	Word w;
	w.sets( Word::MORNING,0 ); 
	for( int i=0;i<maxp;i++ ) {
		if( state.getlive(i) ) people[i].person->Listen( state,w );
	}
	state.tomorror();
}

bool WolfBBS::check( bool *village )
{
	int n=0,m=0;
	for( int i=0;i<maxp;i++ ) {
		if( !state.getlive(i) ) continue;
		if( people[i].type == Wolf ) m++; else n++;
	}
	if( m>=n ) {
		*village = false;
		if( bprint ) printf( "lT̏ł\n" );
		return true;
	}
	if( m==0 ) {
		*village = true;
		if( bprint ) printf( "l̏ł\n" );
		return true;
	}
	return false;
}

void WolfBBS::printstatus()
{
	for( int i=0;i<maxp;i++ ) {
		printf( "%s",state.getlive(i) ? rolesname[people[i].type]:"--" );
	}
	printf( "\n" );
}

bool WolfBBS::oneday( bool *win )
{
	if( bprint ) printf( "%s\n",playernamelist );
	if( bprint ) printstatus();
	tomorror();
	talk();
	augury();
	if( state.getday()>=3 )  {
		hang();
		if( check(win) ) return true;
		wolf();
		if( check(win) ) return true;
	}
	if( bprint ) printf( "\n" );
	return false;
}


extern Init people[];

// --------------------------------------------------------------
int main( int argc,char *argv[] )
{
	WolfBBS wb;

	int n=0,m=0;

	for( int i=1;i<=10000;i++ ) {
		wb.init();
		for( int i=0;people[i].born;i++ ) {
			for( int j=0;j<people[i].num;j++ ) {
				wb.add( people[i].type,people[i].born() );
			}
		}
		wb.shuffle();
//		wb.enableprint();

		bool v;
		while( !wb.oneday(&v) ) ;
		if( v ) n++; else m++;
		if( i%100 == 0 ) printf( "%4d:%4d\n",n,m );
	}

}


